// This demonstrates an error with access specifiers using
// nested classes.

template Templ(T)
{
    class TemplA
    {
    private:
    int val;
    }

    class TemplB
    {
    public:
        this()
        {
            TemplA a = new TemplA();
            a.val = 5;
        }
    }
}

class Class(T)
{
    class ClassA
    {
    private:
        int val;
    }

    this()
    {
        ClassA a = new ClassA();
        a.val = 5; // failure is here
    }
}

int main()
{
    Templ!(int).TemplB tb = new Templ!(int).TemplB();
    Class!(int) cb = new Class!(int)();
    return 0;
}